Thanks for taking the time to consider how you might contribute to the project!


## Reporting Bugs

First, check that the bug has not [already been reported][1]. If no existing
issue addresses the bug, [open a new issue][2] on GitHub. Be sure to include **a
title and a description** that clearly explain the problem with as much detail
as possible; consider attaching **code samples** that demonstrate the unexpected
behavior.


## Patching Code

When ready to submit a patch, [open a new pull request][3] on GitHub. Include
**a clear description** of the problem and your solution, and reference any
relevant open issues.

Code should adhere to the prevailing conventions of the project, which are
similar to that of the Swift standard library. Use two spaces instead of tabs
and end each file with a single newline character.

By submitting a patch, you represent that: (a) you have the right to license the
contribution to this project; (b) you agree to license the contribution under
the project's current [license][4]; and (c) you give permission to re-license
the contribution under any other [Open Source Initiative (OSI)-approved
license][5] that the project may adopt in the future.

[1]: https://github.com/xwu/NumericAnnex/issues
[2]: https://github.com/xwu/NumericAnnex/issues/new
[3]: https://github.com/xwu/NumericAnnex/compare
[4]: https://github.com/xwu/NumericAnnex/blob/master/LICENSE
[5]: https://opensource.org/licenses
